//*****************************************
// AVR ATtiny85 Dekatron(A-102) Spinner Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:tiny85_a102_spinner.c
// 
// fJg `|POQ̓`FbNvO
//
// dnmkdc_łI
//   XCb`ĂȂƐUq
//   XCb`ĂƘA]
//
//@J
//@@u`uq@r@SDPWv{roR
//@@bRpCFuv`uqviv`uq|QOOPPO|DŃCXg[j
//@@ݑuF`uqhro@U
//
//  2016/08/30 New(TAB4)  Taishi
//  2016/10/03 Modify     Taishi dnmŃXCb`܂ŘA̐t݈ړ𑱂
//  2021/02/24 Modify     Taishi Z562S@Ήi_upX fJgj
//  2021/02/25 Modify     Taishi UqɕύX
//  2021/03/24 Modify     Taishi A-102 Ή
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"tiny85_a102_spinner.h"
#include	"Timer.h"
#include	"port_bit.h"
#include	"dekatron.h"
#include	"eep_dat.h"

unsigned char	run_mode = RUN_STEP;

//***************************
// 샂[hύX
//***************************
void	run_mode_change(void)
{
	unsigned char	uc;
	unsigned char	led_stat=1;							// ͓_A͏

	tim_1ms_pendulum = 0;								// kdc_Ŏ

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			run_mode++;
			if(RUN_END <= run_mode){						// 삪͈͊O̎
				run_mode = RUN_STEP;
			}
		}else if(uc == SWR_OFF_LONG){					// 
			cli();										// 荞	s
			write_eep_run_mode();						// ddoqnl 샂[h 
			sei();										// 荞݉
			break;
		}

		if(tim_1ms_pendulum == 0){						// kdc_Ŏ
			switch(led_stat){
				case 0:
					led_on_off(1);						// LEDON
					tim_1ms_pendulum = 2000;			// Qb_
					led_stat++;
					break;
				case 2:
					led_on_off(1);						// LEDON
					tim_1ms_pendulum = 500;				// ODTb_
					led_stat++;
					break;
				case 4:
					if(run_mode == RUN_STEP){			// Xebv샂[h
						led_stat = 0;
					}else{
						led_on_off(1);					// LEDON
						tim_1ms_pendulum = 500;			// ODTb_
						led_stat++;
					}
					break;
				case 6:
					if(run_mode == RUN_SPINNER){		// ]샂[h
						led_stat = 0;
					}else{
						led_on_off(1);					// LEDON
						tim_1ms_pendulum = 500;			// ODTb_
						led_stat++;
					}
					break;
				case 8:
					if(run_mode == RUN_PENDULUM){		// Uq샂[h
						led_stat = 0;
					}else{
						led_on_off(1);					// LEDON
						tim_1ms_pendulum = 500;			// ODTb_
						led_stat++;
					}
					break;
				case 10:
					if(run_mode == RUN_INCHWORM){		// ڎ撎샂[h
						led_stat = 0;
					}else{
						led_on_off(1);					// LEDON
						tim_1ms_pendulum = 500;			// ODTb_
						led_stat++;
					}
					break;
				case 1:
				case 3:
				case 5:
				case 7:
				case 9:
					led_on_off(0);						// LEDOFF
					tim_1ms_pendulum = 500;				// ODTb
					led_stat++;
					break;
				default:
					led_stat = 0;
					break;
			}
		}
	}
}

//***************************
// Main
//***************************
int	main(void)
{
	unsigned char	direction = 0;
	unsigned char	uc;
	unsigned char	i;
	unsigned char	pin=0;

	delay_ms(200);										// 200mS Delay

	sw_init();											// XCb`̏ݒ
	timer0_init();										// Timer0 Initial
	led_init();
	move_init();										// ړi]j̏ݒ

	read_eep_run_mode();								//@ddoqnl 샂[h ǂݍ

	for(uc=0;uc<8;uc++){
		led_on_off(1);									// LEDON
		delay_ms(250);									// 250mS Delay
		led_on_off(0);									// LEDOFF
		delay_ms(250);									// 250mS Delay
	}

	uc = 0;
	if((PINB & SW_RIGHT) == 0){
		delay_ms(100);									// 100mS Delay
		if((PINB & SW_RIGHT) == 0){
			uc = 1;										// {ɉĂ
		}
	}


	sei();

	if(uc == 1){										// XCb`Ă
		led_on_off(1);									// LEDON
		wait_sw_off();									// XCb`@܂ő҂
		led_on_off(0);									// LEDOFF
		run_mode_change();								// 샂[hύX
	}

	i=move_k0();										// jOɋړ
	if(30 <= i){										// ړłȂ
		for(;;){										// ُœ_Ł@iv[v
			led_on_off(1);								// LEDON
			delay_ms(100);								// 250mS Delay
			led_on_off(0);								// LEDOFF
			delay_ms(100);								// 250mS Delay
		}
	}


	if(run_mode == RUN_SPINNER){
		pin = rotate();									//A]
	}else if(run_mode == RUN_PENDULUM){
		pin = pendulum();								//Uq
	}else if(run_mode == RUN_INCHWORM){
		pin = inchworm();								//ڎ撎
	}


	direction = 0;										// ] ]
	tim_10ms_led = 0;

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			if(direction == 0){;						// CW
				if(29 <= pin){
					pin = 0;
				}else{
					pin++;
				}
			}else{										// CCW
				if(pin == 0){
					pin = 29;
				}else{
					pin--;
				}
			}
			n_guid_cathode_move(pin);					//  KChAJ\[hړ ɂȂƎ̃Xebv̕Ȃ
			tim_10ms_led = 10;							// kdc@nm
		}else if(uc == SWR_OFF_LONG){					// 
			direction ^= 1;								// ]ύX
		}else if((uc & SWR_ON_CONTINUE) != 0){			// ꑱ
			if(direction == 0){;						// CW
				if(29 <= pin){
					pin = 0;
				}else{
					pin++;
				}
			}else{										// CCW
				if(pin == 0){
					pin = 29;
				}else{
					pin--;
				}
			}
			n_guid_cathode_move(pin);					// KChAJ\[hړ ɂȂƎ̃Xebv̕Ȃ
			tim_10ms_led = 10;							// kdc@nm
		}

		if(tim_10ms_led == 0){
			led_on_off(0);								// LEDOFF
		}else{
			led_on_off(1);								// LEDON
		}
	}

}
